import 'package:eyflutter_core/dio/enums/content_type.dart';
import 'package:eyflutter_core/dio/enums/method.dart';

class Retrofit {
  /// 接口相对地址
  final String api;

  /// 接口请求方法
  final Method method;

  /// 请求内容数据格式
  final ContentType contentType;

  /// api主机类型
  final int hostType;

  /// 缓存key
  final String cacheKey;

  /// 缓存时间(毫秒)
  final int cacheTime;

  /// 在有效缓存期间启用间隔刷新
  final bool enableIntervalRefresh;

  Retrofit({
    this.api = "",
    this.method = Method.POST,
    this.contentType = ContentType.json,
    this.hostType = 0,
    this.cacheKey = "",
    this.cacheTime = 0,
    this.enableIntervalRefresh = true,
  });
}
